Subject: Re: bug#49953: 28.0.50; tmm is broken on compiled menus

From: Stefan Monnier <[email-masked]>
Date: Mon, 09 Aug 2021 14:23:09 -0400

>> > This regression began to occur after merging native-compilation.
>> > It seems the problem is that tmm-get-keymap does very strange things:
>> >
>> > 	(cond ((if (listp elt)
>> > 		   (or (keymapp elt) (eq (car elt) 'lambda))
>> > 		 (and (symbolp elt) (fboundp elt)))
>> >
>> > I don't know why it checks for 'lambda' and 'symbolp',
>> > but such checks fail on a compiled function.
>> 
>> Yeah, or why the listp at all...  I think the correct test in all these
>> cases are (or (keymapp elt) (functionp elt))?  So I've now done that on
>> the trunk, and that seems to make things work.  But there may be
>> something subtle here, so I guess we'll see...
>
> I have a vague recollection that at least some of those are used, so I
> brought Stefan on-board this discussion, in the hope that he could
> show us the light.

Sorry, my lightbulb is currently out, but I agree that the above test
seems to want to do (or (keymapp elt) (functionp elt)) just in
a clumsy way.

        Stefan